"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../generators/utils");
const plugin = () => {
    return {
        version: 2,
        getEmbeddedCodes(_fileName, sfc) {
            return sfc.styles.map((style, i) => ({
                id: 'style_' + i,
                lang: style.lang,
            }));
        },
        resolveEmbeddedCode(_fileName, sfc, embeddedFile) {
            if (embeddedFile.id.startsWith('style_')) {
                const index = parseInt(embeddedFile.id.slice('style_'.length));
                const style = sfc.styles[index];
                embeddedFile.content.push([
                    style.content,
                    style.name,
                    0,
                    (0, utils_1.enableAllFeatures)({}),
                ]);
            }
        },
    };
};
exports.default = plugin;
//# sourceMappingURL=vue-sfc-styles.js.map